// Code generated by go-swagger; DO NOT EDIT.

// Copyright Authors of Cilium
// SPDX-License-Identifier: Apache-2.0

package bgp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetBgpPeersParams creates a new GetBgpPeersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetBgpPeersParams() *GetBgpPeersParams {
	return &GetBgpPeersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetBgpPeersParamsWithTimeout creates a new GetBgpPeersParams object
// with the ability to set a timeout on a request.
func NewGetBgpPeersParamsWithTimeout(timeout time.Duration) *GetBgpPeersParams {
	return &GetBgpPeersParams{
		timeout: timeout,
	}
}

// NewGetBgpPeersParamsWithContext creates a new GetBgpPeersParams object
// with the ability to set a context for a request.
func NewGetBgpPeersParamsWithContext(ctx context.Context) *GetBgpPeersParams {
	return &GetBgpPeersParams{
		Context: ctx,
	}
}

// NewGetBgpPeersParamsWithHTTPClient creates a new GetBgpPeersParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetBgpPeersParamsWithHTTPClient(client *http.Client) *GetBgpPeersParams {
	return &GetBgpPeersParams{
		HTTPClient: client,
	}
}

/*
GetBgpPeersParams contains all the parameters to send to the API endpoint

	for the get bgp peers operation.

	Typically these are written to a http.Request.
*/
type GetBgpPeersParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get bgp peers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetBgpPeersParams) WithDefaults() *GetBgpPeersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get bgp peers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetBgpPeersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get bgp peers params
func (o *GetBgpPeersParams) WithTimeout(timeout time.Duration) *GetBgpPeersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get bgp peers params
func (o *GetBgpPeersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get bgp peers params
func (o *GetBgpPeersParams) WithContext(ctx context.Context) *GetBgpPeersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get bgp peers params
func (o *GetBgpPeersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get bgp peers params
func (o *GetBgpPeersParams) WithHTTPClient(client *http.Client) *GetBgpPeersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get bgp peers params
func (o *GetBgpPeersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *GetBgpPeersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
